#    SOLDESA es un desarrollo del Departamento de Evaluacion Sensorial de
#    Alimentos del Instituto Superior Experimental de Tecnologia Alimentaria
#    (DESA-ISETA) y de la Comision de Investigaciones Cientificas de la provincia
#    de Buenos Aires (CIC), con la colaboracion de la Cooperativa de Software 
#    Libre ELVEX
#    Mail: graciela@desa.edu.ar
#    Sitio Web: www.desa.edu.ar    
#
#    Copyright (c) 2013 DESA/ISETA   
#    This file is part of Soldesa.
#
#    Soldesa is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Soldesa is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Soldesa.  If not, see <http://www.gnu.org/licenses/>.
from functools import wraps
from flask import session, redirect, g
from flaskext.principal import Permission, RoleNeed,  \
                                RoleNeed, UserNeed, identity_loaded
from couchie.model import User


anon_permission = Permission()
admin_permission = Permission(RoleNeed('admin'))
user_permission = Permission(RoleNeed('user'))
lider_permission = Permission(RoleNeed('lider'))


def logged(perm=None, url_redir='/unautorized'):
    def wrap(oldfunc):
        @wraps(oldfunc)
        def new_func(*args, **kwargs):
            if 'username' not in session:
                return redirect('/login')

            if type(perm) == list:
                for perm_obj in perm:
                    if perm_obj.can():
                        return oldfunc(*args, **kwargs)
                return redirect(url_redir)
            elif perm==None or perm.can():
                return oldfunc(*args, **kwargs)
            else:
                return redirect(url_redir)
        return new_func
    return wrap


@identity_loaded.connect
def on_identity_loaded(sender, identity):
    user = User.view_all[identity.name]
    if user:
        user = user.rows[0]
    # Get the user information from the db
    # Update the roles that a user can provide
    for role in user.roles:
        identity.provides.add(RoleNeed(role))
    # Save the user somewhere so we only look it up once
    identity.user = user
